TestRTperl -I"$TESTRTDIR/lib/perl" -x -S $0
exit
#!perl
#!/usr/bin/perl -w

use FileHandle;
use File::Spec;
STDOUT->autoflush(1);
STDERR->autoflush(1);

my @binList=(
	attolpreproC,attolpostpro,rod2xrd,
	attolstartC,"metcc1 -version",mdl2ptu,utags,
	atoprepro,atopospro,atostart,otags,
	"atspreproC toto toto toto","atspreproCPP toto toto toto",
	"atsspv toto.spv",atsagtd,
	"atsmerge toto","atspostpro toto toto","atsuml -name toto","atsload -SEPARATOR=\"letters\" toto.rod",atsuml,
	atm2stu,
	"attloop -version",attsplit,atlsplit,"perllauncher -version",
	"attolcc1 -version","attolccp -version","attolcov -version",
	"crccc -version","crcld -version",
	attolpreproCPP,attolstartCPP,
	attolpreproADA,attolpostproada,attolstartADA,
	"attolada -version","attolalk -version",attolchop,metada,		
	startjava,"javi -version",javapospro,
	"adatags -version",
	"ctags --version");
my $details=0;

sub GetBinDir
{
    my $BinDir=$ENV{'ATTOLBIN'};
    if ($BinDir eq "") {
        $BinDir = "$ENV{'TESTRTDIR'}/bin/";
        my $RTRT_OS;
        $RTRT_OS = "rs6000/aix" if ($^O =~ /aix/i);
        $RTRT_OS = "hp700/hpux" if ($^O =~ /hpux/i);
        $RTRT_OS = "sun4/sunOS5" if ($^O =~ /solaris/i);
        $RTRT_OS = "intel/win32" if ($^O =~ /win32/i);
        if ($^O =~ /linux/i) {
                if ( -d "/etc/SuSEconfig" ) {
                        $RTRT_OS = "intel/linux_suse";
                }
                else {
                        $RTRT_OS = "intel/linux_redhat";
                }
        }
        $BinDir .= $RTRT_OS;
    }
    return $BinDir;
}

sub executeBin
{
   my $cmd=shift;
   my $Ret;
   my $ver;
   my $vline;
   my $vStr;
#    	open(OLDOUT,">&STDOUT");
#    	open(OLDERR,">&STDERR");
#    	open(STDOUT,">Out.txt");
#    	open(STDERR,">Err.txt");
#    	$Ret=system($cmd);
#    	close(STDOUT);open(STDOUT,">&OLDOUT");
#    	close(STDERR);open(STDERR,">&OLDERR");
#    	close(OLDOUT); close(OLDERR);
    	$Ret=system("$cmd >Out.txt 2>Err.txt");

	open(File,"<Out.txt"); while(<File>) { #IBM Rational Test RealTime Coverage Report Generator 7.5.0.0.276.008
		#if(/IBM\(R\) Rational\(R\) .* (\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		if(/Rational\W.* (\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		{
		   #print ;
		   $ver=$1;
		}
		elsif(/(\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		{
		   $vStr=$1;
		}
		elsif(/\d\.\d/)
		{
		   $vline=$_;
		}
	} close(File);
	unless($ver) {
	    open(File,"<Err.txt"); while(<File>) {
		#if(/IBM\(R\) Rational\(R\) .* (\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		if(/Rational\W.* (\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		{
		   #print ;
		   $ver=$1;
		}
		elsif(/(\d\.\d\.\d\.\d(\.\d+\.\d+)?)/)
		{
		   $vStr=$1 unless($vStr);
		}
		elsif(/\d\.\d/)
		{
		   $vline=$_ unless($vline);
		}
	    } close(File);
	}
	unlink("Out.txt","Err.txt");
	unless($ver)
	{
		$ver=$vStr;
		unless($ver)
		{
			$ver=$vline;

		}
	}
	return $ver;
}

sub main
{
my $ver;
my $attolBinDir=GetBinDir().'/';
  foreach my $bin (@binList){
  
    $ver=executeBin($bin);
    $bin=~s/^(\w+)\s.*/$1/;
    unless(-f "$attolBinDir$bin"){
    	$bin.=".exe" if(-f "$attolBinDir$bin.exe");
    }
    print "$bin \t$ver\n";
    if($details){
    	system("what \"$attolBinDir$bin\"");
    }
  }
return 0;
}

exit(main());
1;
__END__
