#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
#$Id: TestRT_app.pl,v 1.6.2.8 2009/07/26 17:47:39 rfrance Exp $
##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*- eclipse and command line Testing -*-                     #
#                                                                              #
#                                                                              #
# Required global variables:
#   $NAME='PhoneNumber'; #used as node name
#   $TESTPROGRAM='.\\cvisual6\\PhoneNumber.exe';
#   $TESTPROGRAM_ABS='C:\\......\\cvisual6\\PhoneNumber.exe';
#   @OTCFILES = otc file names for C++
#   @COMPILE_SRC = liste des fichiers  compiler
#   @SOURCES = liste des fichiers sources to be linked to the application
#   @EXCLUDE_INSTR_SRC = liste des fichiers  ne pas instrumenter
#   $ATV_INTERMEDIATE_FILE contient la location du fichier .c de la test suite
#   $IS_SEPARATE=0 si le fichier sous test est inclu et 1 si non
#   @COMPILE_SRC=contient la location du  fichier .c de la test suite (compat)
#   @SRC_UNDERTEST=contient les fichiers sous test (.c)
#   si SRC_UNDERTEST contient plus d'un lment IS_SEPARATE=1
################################################################################

# To do output in chronological order when stderr and stdout are both used
use FileHandle;
use File::Spec;
STDOUT->autoflush(1);
STDERR->autoflush(1);

BEGIN {
## globals ############
$TestRTCC=1;
#######################
$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
$TARGETDIR=$ENV{ATLTGT};
$INTDIR=$TARGETDIR;$INTDIR=~s,.*[\\\/](\w+)[\\\/]?$,$1,;
$OUTDIR=$INTDIR;
$INIFILE='tp.ini';
$LOGFILENAME='TestRT.log';
$STAGE='cptler';
  $ATTMODE=0;
  $ATCMODE=0;
  $ATPMODE=0;
  $ATQMODE=0;
  $ATSMODE=0;
  $ATUMODE=0;
  $ATVMODE=0;
  $ATOMODE=0;
  $ATKMODE=0;
  $ATJMODE=0;
$CODE_INSERTION=1;
$ATO_PREPRO_MAX_ERRORS=30;
$PROJECT_NAME='temp';
$PROJECT_PATH='none';
$WORKSPACE_NAME='Local';
$CONFIGURATION=$INTDIR;
@OBJECTS=();
}
my $tmpdir=$ENV{'TEMP'};
if($^O=~/win32/i)
{
    unless($tmpdir){
	$tmpdir=$ENV{'TMP'};
    }
}else{
    $tmpdir=$ENV{'TMPDIR'};
    unless($tmpdir){
	$tmpdir='/tmp';
    }
}

my $envnode="$tmpdir/envTestRT_test.pl";

sub BugTPTP196809
{
   my $dir=shift;
   return unless($dir);
   unless(-f  "$dir/196809.txt"){
	copy($envnode,"$dir/196809.txt");
   }
}

require $SCRIPTDIR . "BatchCCDefaults.pl";
if(@ARGV) {
	if (($ARGV[0] eq "-setting") || ($ARGV[0] eq "-eclipse")) {
		$envnode=$ARGV[1];
                $envnode=~s,\",,g;
		die "unable to find $envnode\n" unless (-f $envnode);
		require $envnode ;
	}else{
		$envnode='';
	}
} else {
	die "unable to find $envnode\n" unless (-f $envnode);
	require $envnode ;
}
  # some options are not available in this mode
#$ATT_ON_THE_FLY=0;

#set minimum required
$XTPFILE = "TestRTccfiles.xtp" unless($XTPFILE);

#require $SCRIPTDIR . "Fcts.pl";

require $SCRIPTDIR . "Source.pl";
require $SCRIPTDIR . "Application.pl";
require $SCRIPTDIR . "VisualTesting.pl";
require $SCRIPTDIR . "metricC.pl";


# some settings are modified by the called scripts
my $savATTMODE;
my $savATCMODE;
my $savATPMODE;
my $savATQMODE;
my $savATSMODE;
my $savATUMODE;
my $savATVMODE;
my $savATOMODE;
my $savATKMODE;
my $savATJMODE;
my @savCOMPLETE_INCLUDE_DIR_LIST;

sub setSettings
{
  $ATTMODE=$savATTMODE;
  $ATCMODE=$savATCMODE;
  $ATPMODE=$savATPMODE;
  $ATQMODE=$savATQMODE;
  $ATSMODE=$savATSMODE;
  $ATUMODE=$savATUMODE;
  $ATVMODE=$savATVMODE;
  $ATOMODE=$savATOMODE;
  $ATKMODE=$savATKMODE;
  $ATJMODE=$savATJMODE;
  @COMPLETE_INCLUDE_DIR_LIST=@savCOMPLETE_INCLUDE_DIR_LIST;
  $CODE_INSERTION=1;

}


sub reports
{
  my $log=shift;
  my $xtp=shift;
  my $tsf;
  my @files;
	open LOG, "<$log";
	while(<LOG>)
	{
		chomp;
		if (/^(TIO|TPF|TQF|TDF|TSF|FDC|MET|CRC|XRD|RTX) (.+)$/){
		  my $f=$2;
		  my $c=$1;
		  my @l=grep(/^\Q$f\E$/, @files);
		  push (@files, $f) unless(scalar(@l) || (($c =~ /TIO|TPF|TQF|TDF/) && !$tsf));
		  if($c eq 'FDC') {$tsf=1;push(@FDCFILES,$f);}
		  if($c eq 'TSF') {$tsf=1;}
		}elsif (/^OTS (.+)$/){
		  push(@OTSFILES,$1);
		  push(@dummy,$1);
		}elsif (/^OBJ (.+)$/){
		  push(@OBJECTS,$1);
		}elsif (/^XOB (.+)$/){
		  push(@XOB,$1);
		  push(@dummy,$1);
		}elsif (/^(DUM|ALK) (.+)$/){
		  push(@dummy,$2);
		}# other lines are ignored
	}
	close(LOG);
	if($xtp) {
		my ($base,$n,$e)=SplitFileName($xtp);
		$base=~s/[\\\/]$//g;
		my $ch;
		my $pwd=GetCurrentDir();
		$ch=1 if($base && ($base ne $pwd));
		$base=$pwd unless($base);

		#print "writing XTP file $xtp, $pwd, $ch, $base\n";
		open XTP, ">$xtp";
		foreach $f (@files) {
		    if($f =~ /^(\w:)?[\\\/]/) {
			$f = File::Spec->abs2rel( $f, $base ) ;
		    } elsif($ch) {
			$f = File::Spec->rel2abs( $f , $pwd ) ;
			$f = File::Spec->abs2rel( $f, $base ) ;
		    }
		    print XTP "$f\n" ;
		}
		close XTP;
		unless($KEEP){
		  	unlink(@dummy); #remove only at the build end
		  	#print "remove ",join("\n       ",@dummy),"\n"; #remove only at the build end
		}
	}
}

sub buildOt
{
	my $otFile=shift;
	$FILENAME=$otFile;
	my ($fdir,$otname,$otext)=SplitFileName($FILENAME);

	$SRCFILE=$otname.'.'.$otext.'.cpp';
	$OTIFILE=$INTDIR.$PATH_SEPARATOR.$otname.'.'.$otext.'.oti';
	
	exit(1) if(TestScript());
}

$BINDIR=GetBinDir() unless($BINDIR);
$BINDIR =  ShortPathName($BINDIR);
$TARGETDIR=ShortPathName($TARGETDIR);
if($WORKING_DIR ne ''){
  chdir($WORKING_DIR);
}

CheckIntDir();
CheckOutDir();
EnterInScript();
BugTPTP196809($INTDIR);
BugTPTP196809($OUTDIR);

# some settings are modified by the called scripts
$savATTMODE=$ATTMODE;
$savATCMODE=$ATCMODE;
$savATPMODE=$ATPMODE;
$savATQMODE=$ATQMODE;
$savATSMODE=$ATSMODE;
$savATUMODE=$ATUMODE;
$savATVMODE=$ATVMODE;
$savATOMODE=$ATOMODE;
$savATKMODE=$ATKMODE;
$savATJMODE=$ATJMODE;

@savCOMPLETE_INCLUDE_DIR_LIST=();
foreach my $i (@COMPLETE_INCLUDE_DIR_LIST){
	$i=$WORKSPACE_PATH.$i if(($i =~ /^[\\\/]/) && (!(-d $i))) ;
	push(@savCOMPLETE_INCLUDE_DIR_LIST,$i);
}
@COMPLETE_INCLUDE_DIR_LIST=@savCOMPLETE_INCLUDE_DIR_LIST;
@OTIFILES=();

print "Current dir: ", GetCurrentDir() ,"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
print "Include Paths:",join(',',@COMPLETE_INCLUDE_DIR_LIST),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
print "source list:",join(',',@SOURCES),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
print "compile:",join(',',@COMPILE_SRC),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
print "linked with:",join(',',@LINKEDFILES),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
print "INTDIR :",$INTDIR,"\n";
print "envNode :",$envnode,"\n";



	#ClearLogFile($LOGFILENAME);
	open LOG, ">$LOGFILENAME";
	print LOG "DIR ",GetCurrentDir() ,"\n";
	close LOG;

	foreach $FILENAME (@DATAPOOLFILENAMES){

		exit(1) if(Source());
	}

#	print "OTC generation:\n";
	foreach (@OTCFILES){
		buildOt($_) ;
	}

	if($ATVMODE && $ATV_INTERMEDIATE_FILE ne '')
	{
		push (@COMPLETE_INCLUDE_DIR_LIST,"$INTDIR");
		push (@COMPLETE_INCLUDE_DIR_LIST,"$TARGETDIR" . "$PATH_SEPARATOR" . "lib");
	    exit(1) if(TestDriverCompil($ATV_INTERMEDIATE_FILE));
	    push(@COMPILE_SRC,@SRC_UNDERTEST) if($IS_SEPARATE);
	}
	if ($STAGE =~ /l/ ){ #link: check non existing obj file to be compiled
	    my @sourceList;
	    foreach $FILENAME (@SOURCES){
		my ($srcdir, $srcname, $srcext) = SplitFileName( $FILENAME );
		my $obj=$INTDIR.$PATH_SEPARATOR.$srcname.'.'.$OBJEXT;
		if(!(-f $obj) || IsOlderThan($obj,$FILENAME)) {
			print $srcname.'.'.$OBJEXT," need to be re-compiled.\n";
			push(@COMPILE_SRC,$FILENAME);
		}else{
			push(@sourceList,$FILENAME);
		}
	    }
	    @SOURCES=@sourceList;
	}
	
#	my $srcFileCnt=0;	
	foreach $FILENAME (@COMPILE_SRC){
		if(grep(/^\Q$FILENAME\E$/,@EXCLUDE_INSTR_SRC)){
			$CODE_INSERTION=0;
		} else {
			setSettings();
		}
		next if($FILENAME eq $ATV_INTERMEDIATE_FILE);# en attendant de le retirer de la liste
		#add targetDir to include path for the first c file to be compiled which is the TestSuite
#		if ($srcFileCnt==0 && $ATVMODE && $TDP_LANGUAGE=~ m/^C/){
#			push (@COMPLETE_INCLUDE_DIR_LIST,"$INTDIR");
#			push (@COMPLETE_INCLUDE_DIR_LIST,"$TARGETDIR" . "$PATH_SEPARATOR" . "lib");
#		}

		exit(1) if(Source());
#		$srcFileCnt++;
	}
	if ($STAGE =~ /l/ ){ #link: build OBJECTS list
		reports($LOGFILENAME,''); #load generated file names from previous compilation
		foreach $FILENAME (@SOURCES){
			my ($srcdir, $srcname, $srcext) = SplitFileName( $FILENAME );
			push(@OBJECTS,$INTDIR.$PATH_SEPARATOR.$srcname.'.'.$OBJEXT);
		}
		push( @OBJECTS, @LINKEDFILES);
		setSettings();
	}
#patch pour bug d'Eric de derniere minute
	if($TESTPROGRAM=~m/\.exe\.exe$/){ $TESTPROGRAM=~s/\.exe//;}
	if($ATL_OUT_FILE=~m/\.exe\./){ $ATL_OUT_FILE=~s/\.exe//;}

	if($ATVMODE) {
	   exit(VisualTesting());
	} else {
	   exit(Application());
	}

1;
