
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2008 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------


-------------------------------------------------------------------------------
-- $Revision: 1.5.2.2 $
-- $Descr: Services for UniTesting TDP Ada$
-- $Id: attol_comm.adb,v 1.5.2.2 2009/07/03 08:49:25 rfrance Exp $
-------------------------------------------------------------------------------
--possible defines are
--RESTR = STD|SMART|DUMP
--RAVENSCAR (incompatible with STD)
--INIT_UNSUPPORTED
--DUMP_C_TRACES

#if RESTR != SMART
with unchecked_conversion;
with system; use system;
#endif
with attol_serv; use attol_serv;
package body attol_comm is

--  subtype T_STRING    is STRING (1 .. 12);
  subtype intervale is integer range 1 .. 3000;

  local_str		: string(intervale)				;
  local_posit		: intervale		:= intervale'first	;


  procedure put(c:character)is
  begin
    local_str(local_posit):=c;
    local_posit:=local_posit+1;
  end put;

  procedure put(s:string) is
  begin
    local_str(local_posit..s'last-s'first+local_posit):=s;
    local_posit:=s'last-s'first+local_posit+1;
  end put;
  procedure put_line(fic:in out priv_file) is
  begin
    if local_posit=1
      then
        priv_writeln(fic,"");
      else
        priv_writeln(fic,local_str(1..local_posit-1));
        local_posit:=1;
      end if;
  end put_line;

  procedure put_dec_image ( VALUE : longest_integer ) is   -- Decimal image of longest_integer.
#if RESTR == DUMP
  i,val:longest_integer;

  begin
    val:=value;
    if val < 0
    then
    put('{');
    while ((val/= -1) and then (val /=0))
      LOOP
        i:= val mod 16;
      if i in 0..9
        then
	  put(character'val(character'pos('0')+i));
	else
	  put(character'val((character'pos('A')-10)+i));
      end if;
	val :=((val +(16-i))/16)-1;
      end loop;
    else
    put('(');
    while(val/=0)
      LOOP
        i:= val mod 16;
      if i in 0..9
        then
	  put(character'val(character'pos('0')+i));
	else
	  put(character'val((character'pos('A')-10)+i));
      end if;
	val :=val /16;
      end loop;
    end if ;
    put('}');
#endif
#if RESTR == SMART
    val		: longest_integer		:= value		;
    index	: integer		:= 0			;
    long	: integer		:= 1			;
    carry	: boolean		:= false			;
    str		: string ( 1 .. longest_integer'width ) := (others => ' '); 
  begin
    if val < 0
    then
        if val < -10000
        then -- unfortunately the biggest negative value cannot be changed to positive value
            carry := true;
            val := val + 10;  -- so reduce the value before sign change 
        end if;
        val	:= 0 - val	;
        str (1)	:= '-'		;
        long	:= 2		;
    end if ;
    loop
      str (str'last - index) := character'val ( (val mod 10)  + 48 ) ;
      val := (val / 10 ) ;
      if (carry)
        then
          carry:=false;
          val := val+1;
      end if;
  
      exit when (val = 0) ;
      index := index + 1 ;
    end loop ;
    for i in reverse 0 .. index
    loop
      str ( index -i + long ) := str (str'last - i) ;
    end loop ;
    put (STR(1..index + long)) ;
#endif
#if RESTR == STD
  s : string ( 1 .. longest_integer'width ) := (others => ' ')	;
  ilen			: integer					;
  begin
    if (value >= 0) then  	-- RA/101
      s(1..longest_integer'image(value)'length-1) := longest_integer'image(value)(2..longest_integer'image(value)'length);
      ilen := longest_integer'image(value)'length-1;
      put (s(1..ilen));
    else
      s(1..longest_integer'image(value)'length) := longest_integer'image(value);
      ilen := longest_integer'image(value)'length;
      put (s(1..ilen));
    end if;
#endif
  end put_dec_image ;

end attol_comm;

