
------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Restricted Material of IBM
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------


-------------------------------------------------------------------------------
-- $Revision: 1.5.2.2 $
-- $Descr: Services for UniTesting TDP Ada$
-- $Id: attol_serv.adb,v 1.5.2.2 2009/07/03 08:49:25 rfrance Exp $
-------------------------------------------------------------------------------


with attol_comm;use attol_comm;
#if RESTR != SMART
with Unchecked_Conversion;
with system; use system;
#endif
#if RESTR == STD
#ifndef INIT_UNSUPPORTED
with text_io;
#endif
#endif

package body attol_serv is

 subtype T_STRING    is STRING (1 .. 12);
--  subtype intervale is integer range 1 .. 3000;

#if RESTR == STD
#ifndef INIT_UNSUPPORTED  remove line below or replace it by a float_io supported provided by your Ada compiler:
  package longest_float_io is new text_io.float_io(longest_float);
#endif
#endif
  procedure put_hex_image ( VALUE : longest_integer ) is -- Hexadecimal image of longest_integer.
    val		: longest_integer		:= value		;
    str		: string ( 1 .. 12 )	:= "            "	;
    index	: integer		:= 0			;
    i		: integer					;
    digit : constant array (0..15) of character :=
      ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
  begin
    loop
      i := integer'val (val mod 16) ;
      str (str'last - index) := digit(i) ;
      val := (val-(longest_integer(i))) / 16 ;
      exit when val = 0 ;
      exit when index=7;
      index := index + 1 ;
    end loop ;
    if str (str'last - index) >='A'
      then
        index:=index+1;
        str (str'last - index):='0';
    end if;
    for k in reverse 0 .. index
    loop
      str ( index -k + 1 ) := str (str'last - k) ;
    end loop ;
    index:=index+2;
    str(index) := 'H';  -- RA/114 
    put( STR(1..index)) ;
  end put_hex_image ;

  procedure put_bin_image ( VALUE : longest_integer ) is  -- Binary image of longest_integer.
    val : longest_integer := value ;
    str  : string ( 1 .. 64 ) := (others => ' ') ;
    index : integer := 0 ;
    ilen:integer:=0;
  begin
    loop
      str (str'last - index) := character'val ((val mod 2) + 48 )  ;
      val := val / 2 ;
      exit when val = 0 ;
      exit when index=63;
      index := index + 1 ;
    end loop ;
    for i in reverse 0 .. index
    loop
      str ( index -i + 1 ) := str (str'last - i) ;
    end loop ;
    index:=index+2;
    str(index) := 'B';  -- RA/114 
    put( STR(1..index)) ;
  end put_bin_image ;


procedure put_string(valeur: in string) is
  in_str : boolean := false;
begin
  if ( valeur'first > valeur'last ) then
    put ("""""");
  else
    for i in valeur'first .. valeur'last loop
--NU:
      if (  i > STRING_MAX_LEN ) then
        put("...");
        exit;
      elsif (valeur(i) < ' ') or (valeur(i) > '~') then 
        if (in_str) then 
          put ("""&\0");
        else
          if (i = valeur'first) then put ("\0");
          else                       put ("&\0");
          end if;
        end if;
        in_str := false;
      else
        if (not in_str) then
          if (i = valeur'first) then put ("""");
          else                       put ("&""");
          end if;
        end if;
        if valeur(i) ='"' then put("""""");
        else put(valeur(i));
        end if;
        in_str := true;
      end if;
    end loop;
    if (in_str) then
      put('"');
    end if;
  end if;
end put_string;

procedure put_enum(valeur: in string) is
begin
  if ( valeur'first >= valeur'last ) then
    put ("""""");
  else
    for i in valeur'first ..  valeur'last loop
--NU:
      if ( i > STRING_MAX_LEN ) then
        put("...");
        exit;
      else
        put(valeur(i));
      end if;
    end loop;
  end if;
end put_enum ;

  procedure put_float_image(X:longest_float) is
#if RESTR == SMART
    un		: constant	:= 1.0e0	;
    dix		: constant	:= 10.0e0	;
    zero	: constant	:= 0.0e0	;
    un_dixieme	: constant	:= 1.0e-1	;
    epsilon	: constant	:= 1.0e-11	;
    expo	: longest_integer	:= 0		;
    signe	: longest_integer	:= 0		;
    n		: longest_integer	:= 0		;
    m		: longest_integer	:= 0		;
    ilen1	: integer	:= 0		;
    p   	: integer	:= 0		;
    f		: longest_float	:= 0.0		;
    g		: longest_float	:= 0.0		;
    h		: longest_float	:= 0.0		;
    e		: longest_float	:= 0.0		;
    l		: longest_float	:= 0.0		;
    expo_str	: t_string	:= (others => ' ');
    s           : string(1..64)  := (others => ' ');
  begin --procedure put_float_image 
    ilen1:=1;
    f:=x;
    if (f=zero)
      then
          S(1..3):="0.0";
          ilen1:=3;
          put(S(1..3));
      else -- not (f=zero)
          if (f<zero)
            then
                signe:=-1;
                s(ilen1):='-';
                ilen1:=ilen1+1;
                f:=(-f);
            else -- not (f<zero)
                signe:=+1;
              end if ; -- (f<zero)
          -- calcul de l'exposant
          g:=f;
          h:=un;
          e:=un;
	  expo:=1;
          if (g>=dix)
            then
                while (g>=dix) AND (expo <=999) loop
                      expo:=expo+1;
                      h:=h*dix;
		      e:=un_dixieme*e;
                      g:=f*e;
                    end loop; -- while (g>=un)
            else -- not (g>=un)
                if (g<un)
                  then
                      while (g<un) AND (expo > -999) loop
                            expo:=expo-1;
		            e:=dix*e;
                            h:=h*un_dixieme;
                            g:=e*f;
                          end loop; -- while (g<un_dixieme)
                  else -- not (g<un)
                      null;
                  end if; -- if (g<un)
              end if; -- if (g>=dix)
          s(ilen1):='0';
          ilen1:=ilen1+1;
          s(ilen1):='.';
          ilen1:=ilen1+1;
	  h:=un;
	  l:=0.0;
	  e:=0.0;
          loop
            begin
	      n:=0;
	      
	      while (((e+h)<g)and n<10)
	      loop
	        e:=e+h;
		n:=n+1;
	      end loop;
	      if n=10
	        then
		  n:=0;
		  p := 1;
		  loop
		  if (s(ilen1-p)='.')
		    then
		      s(ilen1-1-p):=character'succ(s(ilen1-1-p));
		      exit;
		  end if;
		  s(ilen1-p):=character'succ(s(ilen1-p));
		  if (s(ilen1-p)>'9')
		    then
		      s(ilen1-p):='0';
		      p:=p+1;
		    else
		      exit;
		  end if;
		  end loop;
	      end if;
              s(ilen1):= character'val(character'pos('0')+n);
              ilen1:=ilen1+1;
              m:=m+1;
              h:=h/dix;
	      l:=g-e;
              exit when (  l=0.0 OR
	                   (l<epsilon) OR 
			   (e+h= e) OR
	                   (l>=dix*h) OR (m>=Attol_float_nb_digits));
            end;
          end loop;
          if (expo /= 0) then
            s(ilen1):= 'E';
            ilen1:=ilen1+1;
          put(s(1..ilen1-1));
            put_dec_image(longest_integer(expo));
          else
          put(s(1..ilen1-1));
            ilen1:=ilen1-1;
          end if;
        end if; -- if (f=zero)
#endif

#if RESTR == DUMP 
  type octet is range 0..255;
  for octet'size use 8;
  type tabint is array (1..(longest_float'size+octet'size-1)/octet'size) of octet;
  pragma pack(tabint);
     function conv is new Unchecked_Conversion(Source=>longest_float,Target=>tabint);
  y:tabint;
  h,l:octet;
  begin
    y:=conv(x);
    put('!');
    for i in y'range loop
      l:=y(i) mod 16;
      h:= (y(i)-l) / 16;
      if h in 0..9
        then
	  put(character'val(character'pos('0')+h));
	else
	  put(character'val((character'pos('A')-10)+h));
      end if;
      if l in 0..9
        then
	  put(character'val(character'pos('0')+l));
	else
	  put(character'val((character'pos('A')-10)+l));
      end if;
    end loop;
    put('!');
#endif

#if RESTR == STD
  str : string(1..64):= (others => ' ');
  i : integer := str'first;
  begin
#ifndef INIT_UNSUPPORTED remove line below or replace it by a float_io supported provided by your Ada compiler:
    longest_float_io.put(str,x);
#endif
    -- suppression des blancs en debut de chaine
     while ( str(i) = ' ' ) loop i := i + 1; end loop;
    put(str(i..str'last));
#endif
  end put_float_image ; --procedure put_float_image 

  procedure init_float_image(fic:in out priv_file)  is 
  begin 
#if RESTR == DUMP
     put("F2 ");
     put_float_image(3.14159265358979323846);
     put_line(fic);
#endif
     null;
  end;
end attol_serv;

