

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Id: atv.h,v 1.29.2.24 2009/09/18 09:45:36 rfrance Exp $
* $Descr: Unit Testing Header (included across TP.h) $
*******************************************************************************/

#ifndef ATV_H_INCLUDED
#define ATV_H_INCLUDED

#ifdef RTRT_INT64
/*! Largest representable signed integer */
/* see "image.c" ==>  _ATL_LARGEST_INT */
#define _ATV_LARGEST_INT RTRT_INT64
#else
#define _ATV_LARGEST_INT RTRT_INT32
#endif

#ifdef RTRT_U_INT64
/*! Largest representable unsigned integer */
/* see "image.c" ==>  _ATL_LARGEST_U_INT */
#define _ATV_LARGEST_U_INT RTRT_U_INT64
#else
#define _ATV_LARGEST_U_INT RTRT_U_INT32
#endif

#define atv_integer  _ATV_LARGEST_INT
#define atv_unsigned _ATV_LARGEST_U_INT
#define atv_id_type unsigned int
#define atv_ckt_type unsigned char
#define atv_isLit_type unsigned char
#define atv_flag_type unsigned char

#define atl_memcpy priv_memcpy
#define ATV_MEMCPY priv_memcpy
#define ATV_STRCPY atl_strcpy

#ifndef ATV_STUB_CNT_T
#define ATV_STUB_CNT_T RTRT_INT32
#endif
/*
#define ATV_STUB_ENTRY(s) atv_stub_entry(s)
#define ATV_STUB_EXIT(s)  atv_stub_exit()
*/

/**********************************************************/
/* MEMORY_SPACE represent the space memory where are      */
/* stored the strings. Default for this macro is empty    */
/**********************************************************/
#ifndef MEMORY_SPACE
#define MEMORY_SPACE
#endif

#ifndef NULL
#define NULL ((char *)(0))
#endif

#define PRIV_ABS(x) ((x) < 0 ? -(x) : (x))
#ifndef MAXSERIEVALUES
#define MAXSERIEVALUES 9999
#endif

#ifndef RTRT_TDP_COMPILATION

#ifndef RTRT_LOOPVAR_T
#define RTRT_LOOPVAR_T int
#define RTRT_I1 I1
#define RTRT_I2 I2
#define RTRT_I3 I3
#define RTRT_I4 I4
#define RTRT_I5 I5
#define RTRT_I6 I6
#define RTRT_I7 I7

#define RTRT_J1 J1
#define RTRT_J2 J2
#define RTRT_J3 J3
#define RTRT_J4 J4
#define RTRT_J5 J5
#define RTRT_J6 J6
#define RTRT_J7 J7
#endif

#ifndef ATV_ARRAY_MAX_DIM
#define ATV_ARRAY_MAX_DIM 7
#endif

#if ATV_ARRAY_MAX_DIM
extern int _atv_current_idx;
static RTRT_LOOPVAR_T I1;
#if ATV_ARRAY_MAX_DIM >1
static RTRT_LOOPVAR_T I2;
#if ATV_ARRAY_MAX_DIM >2
static RTRT_LOOPVAR_T I3;
#if ATV_ARRAY_MAX_DIM >3
static RTRT_LOOPVAR_T I4;
#if ATV_ARRAY_MAX_DIM >4
static RTRT_LOOPVAR_T I5;
#if ATV_ARRAY_MAX_DIM >5
static RTRT_LOOPVAR_T I6;
#if ATV_ARRAY_MAX_DIM >6
static RTRT_LOOPVAR_T I7;
#endif
#endif
#endif
#endif
#endif
#endif
#endif

#ifndef ATV_FOREACH_MAX
#define ATV_FOREACH_MAX   7
#endif
#if ATV_FOREACH_MAX
static RTRT_LOOPVAR_T J1;
#if ATV_FOREACH_MAX >1
static RTRT_LOOPVAR_T J2;
#if ATV_FOREACH_MAX >2
static RTRT_LOOPVAR_T J3;
#if ATV_FOREACH_MAX >3
static RTRT_LOOPVAR_T J4;
#if ATV_FOREACH_MAX >4
static RTRT_LOOPVAR_T J5;
#if ATV_FOREACH_MAX >5
static RTRT_LOOPVAR_T J6;
#if ATV_FOREACH_MAX >6
static RTRT_LOOPVAR_T J7;
#endif
#endif
#endif
#endif
#endif
#endif
#endif

static int NUM_OPERATION, NUM_TEST;

#endif /* RTRT_TDP_COMPILATION */


extern ATL_TP_PROTO_PREFIX void _atv_i_integer(
#if !RTRT_KR
  atv_integer value,
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX atv_flag_type _atv_e_integer(
#if !RTRT_KR
  atv_ckt_type check,
  atv_integer value,
  atv_id_type id,
  atv_integer value_min,
  atv_integer value_max,
  atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_i_unsigned(
#if !RTRT_KR
  atv_unsigned value,
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX atv_flag_type _atv_e_unsigned(
#if !RTRT_KR
  atv_ckt_type check,
  atv_unsigned value,
  atv_id_type id,
  atv_unsigned value_min,
  atv_unsigned value_max,
  atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;


#define atv_char char
extern ATL_TP_PROTO_PREFIX void _atv_i_char(
#if !RTRT_KR
  char value,
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX atv_flag_type _atv_e_char(
#if !RTRT_KR
  atv_ckt_type check,
  char value,
  atv_id_type id,
  char value_min,
  char value_max,
  atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;

#define atv_boolean int
extern ATL_TP_PROTO_PREFIX void _atv_i_boolean(
#if !RTRT_KR
  atv_boolean value,
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX atv_flag_type _atv_e_boolean(
#if !RTRT_KR
  atv_ckt_type check,
  int value,
  atv_id_type id,
  int value_min,
  int value_max,
  atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;

#if RTRT_FLOAT
#define atv_float float
extern ATL_TP_PROTO_PREFIX void _atv_i_float(
#if !RTRT_KR
  float value,
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX atv_flag_type _atv_e_float(
#if !RTRT_KR
  atv_ckt_type check,
  float value,
  atv_id_type id,
  float value_min,
  float value_max,
  atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;

#define atv_double double
extern ATL_TP_PROTO_PREFIX void _atv_i_double(
#if !RTRT_KR
  double value,
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX atv_flag_type _atv_e_double(
#if !RTRT_KR
  atv_ckt_type check,
  double value,
  atv_id_type id,
  double value_min,
  double value_max,
  atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;

#endif /* RTRT_FLOAT */

#if RTRT_STRING

#ifndef atv_string
#if RTRT_KR
#define atv_string char *
#else /* RTRT_KR */
#define atv_string const char *
#endif /* RTRT_KR */
#endif /* atv_string */

extern ATL_TP_PROTO_PREFIX void _atv_i_string(
#if !RTRT_KR
  atv_string value,
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX atv_flag_type _atv_e_stringl(
#if !RTRT_KR
  atv_ckt_type check,
  unsigned int arraysizeMax,
  atv_string value,
  atv_id_type id,
  atv_string value_min,
  atv_string value_max,
  atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;
#define _atv_e_string(s,t,r,i,n,g) _atv_e_stringl(s,0,t,r,i,n,g)

extern ATL_TP_PROTO_PREFIX int COMP_STR_C(
#if !RTRT_KR
atv_string  atv_s1,
atv_string  atv_s2
#endif
) MEMORY_SPACE;

#if RTRT_STR_CONCAT_SUPPORTED

#ifndef ATU_STRING_SIZE
#define ATU_STRING_SIZE   1024
#endif

extern ATL_TP_PROTO_PREFIX char * CONCAT_STR_C(
#if !RTRT_KR
  atv_string str,
  ...
#endif
) MEMORY_SPACE ;
#else /* RTRT_STR_CONCAT_SUPPORTED */
/* the function CONCAT_STR_C require memory.
 * some TDP can disable this functionality
 */
#define CONCAT_STR_C(str,n) str
#endif /* RTRT_STR_CONCAT_SUPPORTED */
#endif /* RTRT_STRING */

#ifndef atv_pointer
#if RTRT_KR
#define atv_pointer char *
#define _ATU_POINTER_CONVERSION unsigned long
#else /* RTRT_KR */
#define atv_pointer void *
#define _ATU_POINTER_CONVERSION unsigned long
#endif /* RTRT_KR */
#endif /* atv_pointer */

#ifndef _ATU_POINTER_CONVERSION
#error _ATU_POINTER_CONVERSION must be defined with atv_pointer
#endif /* _ATU_POINTER_CONVERSION */

#ifndef NIL
#define NIL (atv_pointer)0
#endif

#ifndef NONIL
#define NONIL (atv_pointer)0
#endif

extern ATL_TP_PROTO_PREFIX atv_flag_type _atv_e_pointer(
#if !RTRT_KR
  atv_ckt_type check,
  atv_pointer value,
  atv_id_type id,
  atv_pointer value_min,
  atv_pointer value_max,
  atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void set_mode_tab(
#if !RTRT_KR
  int numDim,
  int DimSize
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void unset_mode_tab(
#if !RTRT_KR
  int numDim
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_cpy(
#if !RTRT_KR
	unsigned int typesize,
	unsigned int arraysize,
	char* var,
	char* value,
  atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX atv_flag_type _atv_e_array(
#if !RTRT_KR
	atv_ckt_type checkType,unsigned int typesize ,unsigned int arraysize, atv_string var,atv_id_type id,atv_string valueMin,atv_string valueMax,atv_isLit_type isLiteral
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_new_loop(
#if !RTRT_KR
  void
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_check_begin(
#if !RTRT_KR
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_ts_code_begin(
#if !RTRT_KR
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_code_begin(
#if !RTRT_KR
  atv_id_type id,
  char blockType
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_code_end(
#if !RTRT_KR
  atv_id_type id
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_ts_start(
#if !RTRT_KR
  RTRT_U_INT32	key,
  RTRT_U_INT32	cks
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_ts_stop(
#if !RTRT_KR
  void
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_e_chrono_muet(
#if !RTRT_KR
  atv_id_type stub_id,
  int a_status,
  int call_num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_trace_stub(
#if !RTRT_KR
	atv_id_type stub_id,
	int a_status,
	int call_num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX char _atv_nb_call_stub(
#if !RTRT_KR
  atv_id_type stub_id,
  unsigned int value,
  unsigned int value_min,
  char noLimit
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_stub_call_fail(
#if !RTRT_KR
  atv_id_type stub,
  unsigned int ind
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_stub_call_fail_end(
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_tc_start(
#if !RTRT_KR
  atv_id_type num  ,
  const char *name_op,
  RTRT_U_INT32	key,
  RTRT_U_INT32	cks
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX int _atv_tc_stop(
#if !RTRT_KR
  atv_id_type num
#endif
) MEMORY_SPACE ;

extern ATL_TP_PROTO_PREFIX void _atv_end_serie(
#if !RTRT_KR
	atv_id_type id,
	unsigned int level
#endif
) MEMORY_SPACE ;

/* macro used by the atv code generator
   level: is RTRT_Jx where x is the XXX_FOR number
   pos: is the position in the list (starting at 0)
   id: internal temporary var identification
   type: is the type as defined in the type colon
   btype: is the limited base type as char,integer,unsigned,float,double,boolean,pointer,cString
   value: init value or expression
   isNum: 1 if the init value is pure numeric [+\-0-9\.]+

   valueMin: expected value min
   valueMax: expected value max
   isLiteral: 1 if the expected values are both pure numeric [+\-0-9\.]+
   nb: number of test values
   checkType= see define list

   min: from min to max with increment=step
   max: see min
   step: see min

   dim: is RTRT_Ix where x is the dimemtion level
   l: is the indice rank corresponding to dim's x
   size: is the array declaration size
   ptr: is the array pointer
   Rmin: is the Range index min
   Rmax: see Rmin
*/
/* define for checkType 4 msb for float and 4 lsb for others */
#define RTRT_EVCHK0	 0xFE	/* EV_UNCHECK */
#define RTRT_EVCHK1	 0xA1	/* == vmin EV_EQUAL */
#define RTRT_EVCHK2	 0xA6	/* != vmax EV_NOTEQUAL */
#define RTRT_EVCHK3	 0xDC	/* >  vmin EV_GREATER */
#define RTRT_EVCHK4	 0xED	/* >= vmin EV_GREATEROREQUAL */
#define RTRT_EVCHK5	 0x72	/* <  vmax EV_LESS */
#define RTRT_EVCHK6	 0xBA	/* <= vmax EV_LESSOREQUAL */
#define RTRT_EVCHK7	 0xA9	/* [min - max] EV_RANGE_II */
#define RTRT_EVCHK8	 0x61	/* [min - max[ EV_RANGE_IE */
#define RTRT_EVCHK9	 0x98	/* ]min - max] EV_RANGE_EI */
#define RTRT_EVCHK10 0x50	/* ]min - max[ EV_RANGE_EE */
#define RTRT_EVUNCHK RTRT_EVCHK0
#define RTRT_EVCHKNIL RTRT_EVCHK1
#define RTRT_EVCHKNONIL RTRT_EVCHK2

/* macro used to declare a local variable */
#define _ATV_DECLAR(varType,varName) varType varName;
#define _ATV_LOCAL(varType,varName) varType varName;
#define _ATV_CLEAR_integer =0
#define _ATV_CLEAR_char =0
#define _ATV_CLEAR_unsigned =0
#define _ATV_CLEAR_float =0.0
#define _ATV_CLEAR_double =0.0
#define _ATV_CLEAR_boolean =false
#define _ATV_CLEAR_string =""
#define _ATV_CLEAR_pointer =0
#define _ATV_CLEAR_NOT_BTYPE
#define _ATV_CLEAR(btype)  RTRT_CONCAT_MACRO(_ATV_CLEAR_,btype)
#define _ATV_integer_NULL 0
#define _ATV_unsigned_NULL 0
#define _ATV_char_NULL 0
#define _ATV_float_NULL 0.O
#define _ATV_double_NULL 0.0
#define _ATV_boolean_NULL false
#define _ATV_string_NULL ""
#define _ATV_pointer_NULL NULL

/* genere en debut de testcase ou dans la test suite avant le call. l id est genere par la TS alors que le nom par le TC */
#define _ATV_TEST_BEGIN(TC_id,name,key,sck) _atv_tc_start(TC_id,name,key,sck);
#define _ATV_TEST_END(TC_id) return _atv_tc_stop(TC_id);
/* generer en debut d'init */
#define _ATV_LOOP_BEGIN() _atv_new_loop();
#define _ATV_INIT_BEGIN(id) _atv_code_begin(id,'I');
#define _ATV_CHECK_BEGIN(id) _atv_code_begin(id,'C');
/* macro used for simple test init */
#define _ATV_VAR_INI0(id,btype,var) RTRT_CONCAT_MACRO(_atv_i_,btype) ((RTRT_CONCAT_MACRO(atv_,btype))(var),id);
#define _ATV_VAR_INI1(id,btype,var)
#define _ATV_VAR_INI2(id,btype,var)
#define _ATV_VAR_INI4(id,btype,var)
#define _ATV_VAR_INI8(id,btype,var)
#define _ATV_VAR_INIT(id,btype,var,value,isNum) {var = value; RTRT_CONCAT_MACRO(_ATV_VAR_INI,isNum) (id,btype,var)}
#define _ATV_ARRAY_INIT(id,size,type,var,value,isNum) {_atv_cpy(sizeof(type),size,(char*)var,(char*)value,isNum);}
#define _ATV_VAR_NOINIT(id,btype,var) RTRT_CONCAT_MACRO(_atv_i_,btype) ((RTRT_CONCAT_MACRO(atv_,btype))(var),id);
#define _ATV_VAR_EV(id,btype,var,checkType,valueMin,valueMax,isLiteral) \
	RTRT_CONCAT_MACRO(_atv_e_,btype) (checkType,(RTRT_CONCAT_MACRO(atv_,btype))(var),id,(RTRT_CONCAT_MACRO(atv_,btype))valueMin,(RTRT_CONCAT_MACRO(atv_,btype))valueMax,isLiteral);
#define _ATV_ARRAY_EV(id,size,type,var,checkType,valueMin,valueMax,isLiteral) _atv_e_array(checkType,sizeof(type),size,(atv_string)var,id,(atv_string)valueMin,(atv_string)valueMax,isLiteral);
/* macro used for multiple test init. level  */
#define _ATV_EACH_FOR(level,l,nb) {for(level=0;level<nb;level++){
/* END for _ATV_FRMTO_END and _ATV_EACH_END */
#define _ATV_END(id,level) } _atv_end_serie(id,level);}
#define _ATV_EACH_END(id,level) }}
#define _ATV_EACH_LIST(level) switch(level){
//#define _ATV_EACH_ELST(id,level,nb) default: ; }
#define _ATV_EACH_ELST(level,nb) default: ; }
#define _ATV_EACH_INIT(id,level,pos,btype,var,value,isNum) case pos: _ATV_VAR_INIT(id,btype,var,value,isNum) break;
#define _ATV_EACH_NOINIT(id,level,pos,btype,var) case pos: _ATV_VAR_NOINIT(id,btype,var); break;
#define _ATV_EACH_ARRAY_INIT(id,level,pos,size,type,var,value,isNum) case pos: _ATV_ARRAY_INIT(id,size,type,var,value,isNum) break;
#define _ATV_EACH_EV(id,level,pos,btype,var,checkType,valueMin,valueMax,isLiteral) case pos:_ATV_VAR_EV(id,btype,var,checkType,valueMin,valueMax,isLiteral) break;
#define _ATV_EACH_ARRAY_EV(id,level,pos,size,type,var,checkType,valueMin,valueMax,isLiteral) case pos: _ATV_ARRAY_EV(id,size,type,var,checkType,valueMin,valueMax,isLiteral) break;
#define _ATV_EACH_POS_BEGIN(id,level,pos) case pos: {
#define _ATV_EACH_POS_END() } break;
/* macro used for init using from to step loop v2 */
/* pay attention that min,max,step may not be available on the FRMTO_FOR */
#define _ATV_FRMTO_FOR(level,type,var,min,max,step) \
	{ for(level=0;level<MAXSERIEVALUES;level++) {
#define _ATV_FRMTO_END(id,level,var,min,max,step) if(var+step > max)break;} _atv_end_serie(id,level+1);}

#define _ATV_FRMTO_INIT(id,level,btype,type,var,min,max,step) var = (type)(min+(step*(level))); RTRT_CONCAT_MACRO(_atv_i_,btype) ((RTRT_CONCAT_MACRO(atv_,btype))(var),id);
#define _ATV_FRMTO_EV_ASINIT(id,level,btype,var,checkType,min,max,step) _ATV_VAR_EV(id,btype,var,checkType,min+(step*(level)),0,0)

/* macro used for init using from to step loop v3 * /
#define _ATV_FRMTO_FOR(level,type,var,min,max,step) \
	{type RTRT_CONCAT_MACRO(level,_value); for(level=0;level<MAXSERIEVALUES;level++) {
#define _ATV_FRMTO_END(id,level,var,min,max,step) if(var+step > max)break;} _atv_end_serie(id,level);}

#define _ATV_FRMTO_INIT(id,level,btype,type,var,min,max,step) var = (type)((level?min+(step*(level))); RTRT_CONCAT_MACRO(_atv_i_,btype) ((RTRT_CONCAT_MACRO(atv_,btype))(var),id);
#define _ATV_FRMTO_EV_ASINIT(id,level,btype,var,checkType,min,max,step) _ATV_VAR_EV(id,btype,var,checkType,min+(step*(level)),0,0)
*/
/* macro used for array init */
#define _ATV_ARRAY_FOR(dim,l,size) { set_mode_tab(l-1,size); for(dim=0;dim < size; dim++) { _atv_current_idx=dim;
#define _ATV_ARRAY_PTR_FOR(dim,l,ptr,size) { set_mode_tab(l-1,size); for(dim=0; ptr && (dim < size); dim++) { _atv_current_idx=dim;
#define _ATV_ARRAY_END(dim,l,size) } unset_mode_tab(l-1); }
#define _ATV_ARRAY_RANGE(dim,Rmin,Rmax) if((dim <=Rmax) && (dim >=Rmin))
#define _ATV_ARRAY_ELSE() else

/* macro following the call to TC if a code block On Error exist */
#define _ATV_GOTO_ONERROR(label) if(_ATV_TC_status && _ATV_TC_InError==0) goto label;
/* macro used before the code block On Error */
#define _ATV_ERROR_CODE_BEGIN(id) _ATV_TC_InError=1;
#define _ATV_TS_CODE_BEGIN(id) _atv_ts_code_begin(id);

#define _ATV_USER_CODE_BEGIN(id) _atv_code_begin(id,'x');
#define _ATV_USER_CODE_END(id) _atv_code_end(id);
//#define TEST_SUITE_START() char _ATV_TC_status=0;char _ATV_TC_InError=0;_atv_ts_start(9,9);
#define TEST_SUITE_START(key,sck) char _ATV_TC_status=0;char _ATV_TC_InError=0;_atv_ts_start(key,sck);
#define TEST_SUITE_STOP() _atv_ts_stop();

#ifndef _ATV_CHECK_STUBS
#define _ATV_CHECK_STUBS() ;
#endif /* ATV_CHECK_STUBS */


#define _ATV_ARRAY_FOR_STUB(dim,l,size) { for(dim=0;dim < size; dim++) {
#define _ATV_ARRAY_END_STUB(dim,l,size) }  }

#define _ATV_IS_INRANGE(cpt,min,max) ((cpt<=max)&&(cpt>=min))
#define _ATV_VAR_CHKIN(btype,var,checkType,valueMin,valueMax,target) \
     if (!RTRT_CONCAT_MACRO(_atv_e_,btype) (checkType,(RTRT_CONCAT_MACRO(atv_,btype))(var),0,(RTRT_CONCAT_MACRO(atv_,btype))valueMin,(RTRT_CONCAT_MACRO(atv_,btype))valueMax,1)) goto target;

#define _ATV_CHECK_PTR(ptr,target) if (!ptr) goto target;

/* macro used at the end of the TC to check the call numbers for all stubs */
/* macro used by the stubs that should not be called, stub without behavior */
#define _ATV_STUB_CALL_ERROR(stub_id,nbCallFound) {if(nbCallFound) _atv_nb_call_stub(stubID,nbCallFound,0,0);}
#define _ATV_NB_CALL_ERROR(stubID,nbCallFound,EVcall,nolimit) {if(nbCallFound) _atv_nb_call_stub(stubID,nbCallFound,EVcall,nolimit);}

/* macro used during stub execution to dump errors and executions */
#define _ATV_STUB_CALL_FAIL(stub_id,call_num) _atv_stub_call_fail(stub_id,call_num);
#define _ATV_STUB_CALL_FAIL_END(stub_id,call_num) _atv_stub_call_fail_end();
#define _ATV_TRACE_STUB(stub_id,status,call_num) _atv_trace_stub(stub_id,status,call_num);
#define _ATV_NB_CALL_STUB(stubID,nbCallFound,EVcall,nolimit) _atv_nb_call_stub(stubID,nbCallFound,EVcall,nolimit);

#define INI_STR_C(s, aff_val, num, val) atv_ini_str(s, aff_val, num, val)



#endif /* ATV_H_INCLUDED */
