

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Id: products_model.h,v 1.60.4.5 2009/07/31 12:40:01 rfrance Exp $
* $Descr: Studio-modifiable Settings (Parsed by Products.pl) $
*******************************************************************************/

/* Multiple inclusions guard: */
#ifndef PRODUCTS_MODEL_H_INCLUDED
#define PRODUCTS_MODEL_H_INCLUDED


#define ATL_YES      1
#define ATL_NO       0

/* WARNING:
     @PRODUCT@ lines are updated by Perl script ! */

/* Use TestRT Unit Testing */
#ifndef USE_ATU
@PRODUCT@ USE_ATU ATL_YES|ATL_NO
#endif
/* Use TestRT Visual Test */
#ifndef USE_ATV
@PRODUCT@ USE_ATV ATL_YES|ATL_NO
#endif
/* Use TestRT System Testing */
#ifndef USE_ATS
@PRODUCT@ USE_ATS ATL_YES|ATL_NO
#endif
/* Use TestRT Object Testing */
#ifndef USE_ATO
@PRODUCT@ USE_ATO ATL_YES|ATL_NO
#endif
/* Use TestRT Contract Check */
#ifndef USE_ATK
@PRODUCT@ USE_ATK ATL_YES|ATL_NO
#endif
/* Use TestRT Coverage */
#ifndef USE_ATC
@PRODUCT@ USE_ATC ATL_YES|ATL_NO
#endif
/* Use TestRT Trace */
#ifndef USE_ATT
@PRODUCT@ USE_ATT ATL_YES|ATL_NO
#endif
/* Use TestRT PurifyLT */
#ifndef USE_ATP
@PRODUCT@ USE_ATP ATL_YES|ATL_NO
#endif
/* Use TestRT QuantifyLT */
#ifndef USE_ATQ
@PRODUCT@ USE_ATQ ATL_YES|ATL_NO
#endif

#ifndef USE_ATU
#define USE_ATU ATL_NO
#endif
#ifndef USE_ATV
#define USE_ATV ATL_NO
#endif
#ifndef USE_ATS
#define USE_ATS ATL_NO
#endif
#ifndef USE_ATO
#define USE_ATO ATL_NO
#endif
#ifndef USE_ATK
#define USE_ATK ATL_NO
#endif
#ifndef USE_ATC
#define USE_ATC ATL_NO
#endif
#ifndef USE_ATT
#define USE_ATT ATL_NO
#endif
#ifndef USE_ATP
#define USE_ATP ATL_NO
#endif
#ifndef USE_ATQ
#define USE_ATQ ATL_NO
#endif



/*******************************************************************************
* TestRT Unit Testing:
*******************************************************************************/


@ATU@ ATU_BREAK_ON_TEST_FAILED ATL_NO|ATL_YES
#ifndef ATU_BREAK_ON_TEST_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATU_BREAK_ON_TEST_FAILED ATL_NO
#endif

#if USE_ATU
/* file regenrated by attolpreproC for runtime optimization */
@ATU@ ATU_OPTIM_INCLUDE attol_cfg.h
#endif

/*******************************************************************************
* TestRT Visual Test:
*******************************************************************************/


@ATV@ ATV_BREAK_ON_TEST_FAILED ATL_NO|ATL_YES
#ifndef ATV_BREAK_ON_TEST_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATV_BREAK_ON_TEST_FAILED ATL_NO
#endif

#if USE_ATV
/* file regenrated by ATV for runtime optimization */
@ATV@ ATV_OPTIM_INCLUDE testSuite.h
#endif

@ATV@ ATV_REPORT_OUTLAY 0|1|2
#ifndef ATV_REPORT_OUTLAY
/*! standard mode expand arrays */
#define ATV_REPORT_OUTLAY 0
#endif

/*******************************************************************************
* TestRT System Testing:
*******************************************************************************/


@ATS@ ATS_BUFFER_SIZE <number>
#ifndef ATS_BUFFER_SIZE
/*! Size in bytes of buffer (used to store string vars and lines) */
#define ATS_BUFFER_SIZE 1024
#endif

@ATS@ ATS_TAGTBUF_SIZE <number>
#ifndef ATS_TAGTBUF_SIZE
/*! Maximum size in bytes of lines raised by testers */
#define ATS_TAGTBUF_SIZE 4096
#endif

@ATS@ ATS_RT_BUFFER ATL_YES|ATL_NO
#ifndef ATS_RT_BUFFER
/*! Use bufferized items */
#define ATS_RT_BUFFER ATL_NO
#endif

@ATS@ ATS_DYNFLW ATL_YES|ATL_NO
#ifndef ATS_DYNFLW
/*! Activates dynamic tracking */
#define ATS_DYNFLW ATL_NO
#endif

@ATS@ ATS_INTERRECV_TIMEOUT <number>
#ifndef ATS_INTERRECV_TIMEOUT
/*! Timeout for INTERRECV instruction */
#define ATS_INTERRECV_TIMEOUT 300
#endif

@ATS@ ATS_THREAD_LAUNCHER ATL_YES|ATL_NO
#ifndef ATS_THREAD_LAUNCHER
/*! Timeout for INTERRECV instruction */
#define ATS_THREAD_LAUNCHER ATL_YES
#endif

@ATS@ ATS_THREAD_FUNCTION <ATL_Start>
#ifndef ATS_THREAD_FUNCTION
/*! Timeout for INTERRECV instruction */
#define ATS_THREAD_FUNCTION ATL_Start
#define ATS_THREAD_TABLE ATL_Start_Table
#define ATS_THREAD_TABLELEN ATL_Start_TableLen
#endif

/*******************************************************************************
* TestRT Object Testing:
*******************************************************************************/


@ATO@ ATO_BREAK_ON_CHECK_FAILED ATL_NO|ATL_YES
#ifndef ATO_BREAK_ON_CHECK_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATO_BREAK_ON_CHECK_FAILED ATL_NO
#endif

@ATO@ ATO_DUMP_SUCCESS ATL_NO|ATL_YES
#ifndef ATO_DUMP_SUCCESS
/*! Also dumps successful checks in traces */
#define ATO_DUMP_SUCCESS 1
#endif

@ATO@ ATO_MAX_INSTANCES <number>
#ifndef ATO_MAX_INSTANCES
/*! Size of instances stack */
#define ATO_MAX_INSTANCES 256
#endif

@ATO@ ATO_PRINT_BUFFER_SIZE <number>
#ifndef ATO_PRINT_BUFFER_SIZE
/* Size of PRINT buffer (0 means no buffering: PRINT arguments are displayed
 * on separate notes) */
#define ATO_PRINT_BUFFER_SIZE 512
#endif


/*******************************************************************************
* TestRT Contract Check:
*******************************************************************************/


@ATK@ ATK_BREAK_ON_ASSERT_FAILED ATL_NO|ATL_YES
#ifndef ATK_BREAK_ON_ASSERT_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATK_BREAK_ON_ASSERT_FAILED 0
#endif

@ATK@ ATK_DUMP_SUCCESS ATL_NO|ATL_YES
#ifndef ATK_DUMP_SUCCESS
/*! Also dumps successful assertions in traces */
#define ATK_DUMP_SUCCESS 0
#endif



/*******************************************************************************
* TestRT Coverage:
*******************************************************************************/


/* 0: pass mode,
 * 1: compact mode,
 * 2: count mode */
@ATC@ ATC_INFORMATION 0|1|2
#ifndef ATC_INFORMATION
/* pass mode */
#define ATC_INFORMATION 0
#endif

@ATC@ ATC_DUMP_DRIVER ATL_YES|ATL_NO
#ifndef ATC_DUMP_DRIVER
/* Dump Driver use */
#define ATC_DUMP_DRIVER ATL_NO
#endif

@ATC@ ATC_ON_THE_FLY <number>
#ifndef ATC_ON_THE_FLY
#define ATC_ON_THE_FLY 0
#endif


/*******************************************************************************
* TestRT Trace:
*******************************************************************************/


@ATT@ ATT_ON_THE_FLY ATL_YES|ATL_NO
#ifndef ATT_ON_THE_FLY
/* Trace On The Fly (natives only) */
#define ATT_ON_THE_FLY ATL_YES
#endif

@ATT@ ATT_ITEMS_MAX <number>
#ifndef ATT_ITEMS_MAX
/* Maximum Number of Buffered Items */
#define ATT_ITEMS_MAX 0
#endif

@ATT@ ATT_DUMP_FROM_BEGINNING ATL_YES|ATL_NO
#ifndef ATT_DUMP_FROM_BEGINNING
/* No Partial Message Dump: if ATL_YES, message dump starting, stopping and
   toggling and stack dump are not available */
#define ATT_DUMP_FROM_BEGINNING ATL_YES
#endif

/* Action Associated to Signal Handling */
#define ATT_SIGNAL_TOGGLE_DUMP 1
#define ATT_SIGNAL_DUMP_CALL_STACK 2

@ATT@ ATT_SIGNAL ATL_NO|ATT_SIGNAL_TOGGLE_DUMP|ATT_SIGNAL_DUMP_CALL_STACK
#ifndef ATT_SIGNAL
/* Possible Values for ATT_SIGNAL:
   ATL_NO, ATT_SIGNAL_TOGGLE_DUMP or ATT_SIGNAL_DUMP_CALL_STACK */
#define ATT_SIGNAL ATL_NO
#endif

@ATT@ ATT_COMPUTE_MAX_CALLING_LEVEL ATL_YES|ATL_NO
#ifndef ATT_COMPUTE_MAX_CALLING_LEVEL
/* Computes Maximum Call Stack Size and Display it in a Note */
#define ATT_COMPUTE_MAX_CALLING_LEVEL ATL_NO
#endif

@ATT@ ATT_TIMESTAMP ATL_YES|ATL_NO
#ifndef ATT_TIMESTAMP
/* Time Stamping of UML/SD Messages: */
#define ATT_TIMESTAMP ATL_NO
#endif


/* multi-threaded applications only: */

@ATT@ ATT_THREAD_INFO ATL_YES|ATL_NO
#ifndef ATT_THREAD_INFO
/* thread info is computed or not */
#define ATT_THREAD_INFO ATL_NO
#endif



/*******************************************************************************
* TestRT PurifyLT:
*******************************************************************************/


@ATP@ ATP_CALL_STACK_SIZE <number>
#ifndef ATP_CALL_STACK_SIZE
/* How Many Call Stack Items in each Memory Block Description */
#define ATP_CALL_STACK_SIZE 6
#endif

@ATP@ ATP_REPORTS_FIU ATL_YES|ATL_NO
#ifndef ATP_REPORTS_FIU
/* File In Use Reporting */
#define ATP_REPORTS_FIU ATL_NO
#endif

@ATP@ ATP_REPORTS_FFM_FMWL ATL_YES|ATL_NO
#ifndef ATP_REPORTS_FFM_FMWL
/* Late Detect Free Memory Write Reporting */
#define ATP_REPORTS_FFM_FMWL ATL_YES
#endif

@ATP@ ATP_REPORTS_FIM ATL_YES|ATL_NO
#ifndef ATP_REPORTS_FIM
/* Late Detect Free Memory Write Reporting */
#define ATP_REPORTS_FIM ATL_NO
#endif

@ATP@ ATP_MAX_FREEQ_LENGTH <number>
#ifndef ATP_MAX_FREEQ_LENGTH
/* Maximum Number of Memory Blocks Kept in the Free Queue */
#define ATP_MAX_FREEQ_LENGTH 100
#endif

@ATP@ ATP_MAX_FREEQ_SIZE <number>
#ifndef ATP_MAX_FREEQ_SIZE
/* Maximum Number of Bytes Kept Unfreed in the Free Queue */
#define ATP_MAX_FREEQ_SIZE 1000000
#endif

@ATP@ ATP_MAX_FREEQ_BLOCK_SIZE <number>
#ifndef ATP_MAX_FREEQ_BLOCK_SIZE
/* Maximum Number of Bytes Kept Unfreed in the Free Queue */
#define ATP_MAX_FREEQ_BLOCK_SIZE 1000000
#endif

@ATP@ ATP_REPORTS_ABWL ATL_YES|ATL_NO
#ifndef ATP_REPORTS_ABWL
/* Late Detect Array Bounds Write Reporting */
#define ATP_REPORTS_ABWL ATL_YES
#endif

@ATP@ ATP_CHECK_SELECTED_BLOCKS ATL_YES|ATL_NO
#ifndef ATP_CHECK_SELECTED_BLOCKS
/* allows ABWL and FMWL detection on selective list of memory blocks */
#define ATP_CHECK_SELECTED_BLOCKS ATL_NO
#endif

@ATP@ ATP_BREAK_ON_ERROR ATL_YES|ATL_NO
#ifndef ATP_BREAK_ON_ERROR
/* allows breaking the code under debug when ATP errors are detected */
#define ATP_BREAK_ON_ERROR ATL_NO
#endif

@ATP@ ATP_RED_ZONE_SIZE <number>
#ifndef ATP_RED_ZONE_SIZE
/* Size in Bytes of each of the two Red Zones
 * (one before and one after the Tracked Memory Block) */
#define ATP_RED_ZONE_SIZE 16
#endif

@ATP@ ATP_REPORTS_MIU ATL_YES|ATL_NO
#ifndef ATP_REPORTS_MIU
/* Memory In Use Reporting */
#define ATP_REPORTS_MIU ATL_NO
#endif

@ATP@ ATP_REPORTS_SIG ATL_YES|ATL_NO
#ifndef ATP_REPORTS_SIG
/* Signal Handled Reporting */
#define ATP_REPORTS_SIG ATL_NO
#endif

@ATP@ ATP_KEEP_CONTENT ATL_YES|ATL_NO
#ifndef ATP_KEEP_CONTENT
/* Signal Handled Reporting */
#define ATP_KEEP_CONTENT ATL_NO
#endif

@ATP@ ATP_NO_TRACK_ALLOCS_BEFORE_INIT ATL_YES|ATL_NO
#ifndef ATP_NO_TRACK_ALLOCS_BEFORE_INIT
/* Signal Handled Reporting */
#define ATP_NO_TRACK_ALLOCS_BEFORE_INIT ATL_NO
#endif

@ATP@ ATP_DUMP_BLOCK_ONLY_ONCE ATL_YES|ATL_NO
#ifndef ATP_DUMP_BLOCK_ONLY_ONCE
/* dump MLK and MPK only once in multi-dump */
#define ATP_DUMP_BLOCK_ONLY_ONCE ATL_NO
#endif

@ATP@ ATP_DUMP_UNFREED_ONLY_WITH_STACK ATL_YES|ATL_NO
#ifndef ATP_DUMP_UNFREED_ONLY_WITH_STACK
/* dump MLK and MPK  and MIU only if the call stack is available */
#define ATP_DUMP_UNFREED_ONLY_WITH_STACK ATL_NO
#endif

/*******************************************************************************
* TestRT QuantifyLT:
*******************************************************************************/


@ATQ@ ATQ_COMPUTE_OVERHEAD ATL_YES|ATL_NO
#ifndef ATQ_COMPUTE_OVERHEAD
/* Computes Overhead on Measures Due to Its Measurement */
#define ATQ_COMPUTE_OVERHEAD ATL_NO
#endif

@ATQ@ ATQ_DUMP_DRIVER ATL_YES|ATL_NO
#ifndef ATQ_DUMP_DRIVER
/* Dump Driver use */
#define ATQ_DUMP_DRIVER ATL_NO
#endif

@ATQ@ ATQ_COMPUTE_MINMAX ATL_YES|ATL_NO
#ifndef ATQ_COMPUTE_MINMAX
/* Dump Driver use */
#define ATQ_COMPUTE_MINMAX ATL_NO
#endif

/*******************************************************************************
* Several products settings:
*******************************************************************************/

@ATL@ ATL_MULTI_THREADS ATL_YES|ATL_NO
#ifndef ATL_MULTI_THREADS
/*! Multi-threaded Application */
#define ATL_MULTI_THREADS ATL_NO
#endif

@ATL@ ATL_MULTI_PROCESS ATL_YES|ATL_NO
#ifndef ATL_MULTI_PROCESS
/*! Multi-process Application */
#define ATL_MULTI_PROCESS ATL_NO
#endif

@ATL@ ATL_THREADS_MAX <number>
#ifndef ATL_THREADS_MAX
/*! Threads Table Size */
#define ATL_THREADS_MAX 64
#endif

@ATL@ ATL_BUFFER_SIZE <number>
#ifndef ATL_BUFFER_SIZE
/*! I/O Optimisation Buffer Size In Bytes */
#define ATL_BUFFER_SIZE 16384
#endif

@ATL@ ATL_NODE_NAME "<string>"
#ifndef ATL_NODE_NAME
/*! Application Node Name */
#define ATL_NODE_NAME ".root."
#endif

@ATL@ ATL_MIME_NAME "<string>"
#ifndef ATL_MIME_NAME
/*! Unicode Mime Name (default to US english) */
#define ATL_MIME_NAME "ISO-8859-1"
#endif

@ATL@ ATL_TRACES_FILE "<string>"
#ifndef ATL_TRACES_FILE
/*! Traces File Name */
#define ATL_TRACES_FILE "atlout.spt"
#define ATL_TRACES_FILE_LEN 10
#endif

#define ATL_OS_CLOCK 1
#define ATL_PROCESS_CLOCK 2
@ATL@ ATL_CLOCK_KIND ATL_OS_CLOCK|ATL_PROCESS_CLOCK
#ifndef ATL_CLOCK_KIND
/*! Clock type : OS or process */
#define ATL_CLOCK_KIND ATL_OS_CLOCK
#endif

@ATL@ ATL_DUMP_ON_RETURNING |_ATP_CHK
#ifndef ATL_DUMP_ON_RETURNING
/* define ABWL & FMWL check frequency (on each function returning) mempro only */
#define ATL_DUMP_ON_RETURNING
#endif

@ATL@ ATL_DYN_TABLE ATL_YES|ATL_NO
#ifndef ATL_DYN_TABLE
/* define if instrumentation table for ATC, ATQ ATP must be allocated in the Heap */
#define ATL_DYN_TABLE ATL_NO
#endif

#define ATL_OBJ 0 /* object file used at link */
#define ATL_DLL 1 /* dynamic libray */
#define ATL_LIB 2 /* static libray */

@ATL@ ATL_RUNTIME_FORMAT    ATL_OBJ|ATL_DLL|ATL_LIB
#ifndef ATL_RUNTIME_FORMAT
/* define check frequency (on each function returning) */
#define ATL_RUNTIME_FORMAT ATL_OBJ
#endif

@ATL@ ATL_USE_VOLATIL_DLL ATL_YES|ATL_NO
#ifndef ATL_USE_VOLATIL_DLL
/*! Multi-process Application */
#define ATL_USE_VOLATIL_DLL ATL_NO
#endif

@ATL@ ATL_CHECK_STACK ATL_YES|ATL_NO
#ifndef ATL_CHECK_STACK
/*! Multi-process Application */
#define ATL_CHECK_STACK ATL_NO
#endif

@ATL@ ATL_SIGNAL_DUMP ATL_YES|ATL_NO
#ifndef ATL_SIGNAL_DUMP
/*! Dump on signal */
#define ATL_SIGNAL_DUMP ATL_NO
#endif  /* ATL_SIGNAL_DUMP */


/*******************************************************************************
* Some TDP settings:
*******************************************************************************/

/* TDP $Ini{RUNTIME_DEFINES}  do not remove this line */

#endif
